﻿using System;
using System.Diagnostics;
using System.Windows;
using System.Windows.Threading;
using Arction.Wpf.SemibindableCharting;
using Arction.Wpf.SemibindableCharting.SeriesXY;
using Arction.Wpf.SemibindableCharting.Views.ViewXY;

namespace HeatmapTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            this.DataContextChanged += MainWindow_DataContextChanged;
            InitializeComponent();
            CreateChart();
        }

        private void MainWindow_DataContextChanged(object sender, DependencyPropertyChangedEventArgs e)
        {
            var vm = (MainWindowViewModel)this.DataContext;
            vm.UpdateChartInView = UpdateChart;

            //Call VM Method
            vm?.StartInVM();
        }

        void CreateChart()
        {
            m_heatmap.MouseTraceCellChanged += new IntensitySeriesBase.MouseTraceCellChangedHandler(heatmap_MouseTraceCellChanged);
        }

        void heatmap_MouseTraceCellChanged(IntensitySeriesBase sender, int mouseX, int mouseY, int newCellColumn, int newCellRow, int nearestDataColumnIndex, int nearestDataRowIndex, IntensityPoint nearestCellCorner, float nearestCellCornerCoordX, float nearestCellCornerCoordY)
        {
            Debug.WriteLine($"Mouse trace [{newCellColumn}][{newCellRow}] = {sender.Data[newCellColumn, newCellRow].Value:0.0}");
        }

        //Call from VM
        private void UpdateChart()
        {
            m_chart.BeginUpdate();
            m_heatmap.InvalidateValuesDataOnly();
            m_chart.EndUpdate();
        }

    }
}
